package org.jeecg.modules.fbsRdrecord32.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.fbsRdrecord32.entity.FbsRdrecord32;
import org.jeecg.modules.fbsRdrecord32.service.IFbsRdrecord32Service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;

 /**
 * @Title: Controller
 * @Description: 销售出库单主表（表头）
 * @author： jeecg-boot
 * @date：   2020-10-22
 * @version： V1.0
 */
@RestController
@RequestMapping("/fbsRdrecord32/fbsRdrecord32")
@Slf4j
public class FbsRdrecord32Controller {
	@Autowired
	private IFbsRdrecord32Service fbsRdrecord32Service;
	
	/**
	  * 分页列表查询
	 * @param fbsRdrecord32
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/list")
	public Result<IPage<FbsRdrecord32>> queryPageList(FbsRdrecord32 fbsRdrecord32,
									  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
									  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
									  HttpServletRequest req) {
		Result<IPage<FbsRdrecord32>> result = new Result<IPage<FbsRdrecord32>>();
		QueryWrapper<FbsRdrecord32> queryWrapper = QueryGenerator.initQueryWrapper(fbsRdrecord32, req.getParameterMap());
		Page<FbsRdrecord32> page = new Page<FbsRdrecord32>(pageNo, pageSize);
		IPage<FbsRdrecord32> pageList = fbsRdrecord32Service.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}
	
	/**
	  *   添加
	 * @param fbsRdrecord32
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<FbsRdrecord32> add(@RequestBody FbsRdrecord32 fbsRdrecord32) {
		Result<FbsRdrecord32> result = new Result<FbsRdrecord32>();
		try {
			fbsRdrecord32Service.save(fbsRdrecord32);
			result.success("添加成功！");
		} catch (Exception e) {
			e.printStackTrace();
			log.info(e.getMessage());
			result.error500("操作失败");
		}
		return result;
	}
	
	/**
	  *  编辑
	 * @param fbsRdrecord32
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<FbsRdrecord32> edit(@RequestBody FbsRdrecord32 fbsRdrecord32) {
		Result<FbsRdrecord32> result = new Result<FbsRdrecord32>();
		FbsRdrecord32 fbsRdrecord32Entity = fbsRdrecord32Service.getById(fbsRdrecord32.getId());
		if(fbsRdrecord32Entity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fbsRdrecord32Service.updateById(fbsRdrecord32);
			//TODO 返回false说明什么？
			if(ok) {
				result.success("修改成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<FbsRdrecord32> delete(@RequestParam(name="id",required=true) String id) {
		Result<FbsRdrecord32> result = new Result<FbsRdrecord32>();
		FbsRdrecord32 fbsRdrecord32 = fbsRdrecord32Service.getById(id);
		if(fbsRdrecord32==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fbsRdrecord32Service.removeById(id);
			if(ok) {
				result.success("删除成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<FbsRdrecord32> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<FbsRdrecord32> result = new Result<FbsRdrecord32>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.fbsRdrecord32Service.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}
	
	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<FbsRdrecord32> queryById(@RequestParam(name="id",required=true) String id) {
		Result<FbsRdrecord32> result = new Result<FbsRdrecord32>();
		FbsRdrecord32 fbsRdrecord32 = fbsRdrecord32Service.getById(id);
		if(fbsRdrecord32==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(fbsRdrecord32);
			result.setSuccess(true);
		}
		return result;
	}

  /**
      * 导出excel
   *
   * @param request
   * @param response
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
      // Step.1 组装查询条件
      QueryWrapper<FbsRdrecord32> queryWrapper = null;
      try {
          String paramsStr = request.getParameter("paramsStr");
          if (oConvertUtils.isNotEmpty(paramsStr)) {
              String deString = URLDecoder.decode(paramsStr, "UTF-8");
              FbsRdrecord32 fbsRdrecord32 = JSON.parseObject(deString, FbsRdrecord32.class);
              queryWrapper = QueryGenerator.initQueryWrapper(fbsRdrecord32, request.getParameterMap());
          }
      } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
      }

      //Step.2 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      List<FbsRdrecord32> pageList = fbsRdrecord32Service.list(queryWrapper);
      //导出文件名称
      mv.addObject(NormalExcelConstants.FILE_NAME, "销售出库单主表（表头）列表");
      mv.addObject(NormalExcelConstants.CLASS, FbsRdrecord32.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("销售出库单主表（表头）列表数据", "导出人:Jeecg", "导出信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
  }

  /**
      * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<FbsRdrecord32> listFbsRdrecord32s = ExcelImportUtil.importExcel(file.getInputStream(), FbsRdrecord32.class, params);
              for (FbsRdrecord32 fbsRdrecord32Excel : listFbsRdrecord32s) {
                  fbsRdrecord32Service.save(fbsRdrecord32Excel);
              }
              return Result.ok("文件导入成功！数据行数：" + listFbsRdrecord32s.size());
          } catch (Exception e) {
              log.error(e.getMessage());
              return Result.error("文件导入失败！");
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.ok("文件导入失败！");
  }

}
